#!/bin/sh

. /lib/security-functions.sh

root_device=$(getarg 'root=')

securityfs_mnt=/sys/kernel/security
sysfs_entry="$securityfs_mnt"/kysec/3adm
selinuxfs_mnt=/sys/fs/selinux

if [ "yes" != "$(securityfs_is_mounted)" ]; then
	mount -t securityfs none "$securityfs_mnt"
	if [ $? -ne 0 ]; then
		panic "Failed to mount securityfs"
		exit 0
	fi
fi

mount -o remount,rw "${root_device}" "${NEWROOT}"
if [ -f "$sysfs_entry" ]; then
	adm_status=`cat "$sysfs_entry"`

	if [ x"${adm_status}" = x"0" ];then
		[ -f ${NEWROOT}/etc/kysec/db/whlist.db ] && \
			chown 0:0 ${NEWROOT}/etc/kysec/db/whlist.db
                [ -f ${NEWROOT}/usr/share/dbus-1/system-services/com.kylin.kysec.service ] && \
			sed -i /^User=/cUser=root ${NEWROOT}/usr/share/dbus-1/system-services/com.kylin.kysec.service
		[ -f ${NEWROOT}/lib/systemd/system/kysec-sync-notify.service ] && \
			sed -i /^User=/cUser=root ${NEWROOT}/lib/systemd/system/kysec-sync-notify.service
	else
		[ -f ${NEWROOT}/etc/kysec/db/whlist.db ] && \
			chown 600:600 ${NEWROOT}/etc/kysec/db/whlist.db
		[ -f ${NEWROOT}/usr/share/dbus-1/system-services/com.kylin.kysec.service ] && \
			sed -i /^User=/cUser=secadm ${NEWROOT}/usr/share/dbus-1/system-services/com.kylin.kysec.service
		[ -f ${NEWROOT}/lib/systemd/system/kysec-sync-notify.service ] && \
			sed -i /^User=/cUser=secadm ${NEWROOT}/lib/systemd/system/kysec-sync-notify.service
	fi

	# disable 3adm
	echo 0 > "$sysfs_entry"
	echo $adm_status > /.3adm
	info "kysec 3adm disabled"
else
	[ -f ${NEWROOT}/etc/kysec/db/whlist.db ] && \
		chown 0:0 ${NEWROOT}/etc/kysec/db/whlist.db
        [ -f ${NEWROOT}/usr/share/dbus-1/system-services/com.kylin.kysec.service ] && \
		sed -i /^User=/cUser=root ${NEWROOT}/usr/share/dbus-1/system-services/com.kylin.kysec.service
	[ -f ${NEWROOT}/lib/systemd/system/kysec-sync-notify.service ] && \
		sed -i /^User=/cUser=root ${NEWROOT}/lib/systemd/system/kysec-sync-notify.service
fi

unset root_device
