#!/bin/sh

sysfs_entry=/sys/kernel/security/kysec/3adm

. /lib/security-functions.sh

root_device=$(getarg 'root=')

securityfs_mnt=/sys/kernel/security
sysfs_entry="$securityfs_mnt"/kysec/3adm

mount -o remount,rw "${root_device}" "${NEWROOT}"

if [ -f "$sysfs_entry" ]; then
	adm_status = `cat "$sysfs_entry"`
        if [ x"${adm_status}" = x"0" ];then
                chown -R 0:0 ${NEWROOT}/etc/selinux
                chown -R 0:0 ${NEWROOT}/usr/share/selinux
                chown -R 0:0 ${NEWROOT}/var/lib/sepolgen
                chown -R 0:0 ${NEWROOT}/var/lib/selinux
                chown -R 0:0 ${NEWROOT}/etc/audi*
                chown -R 0:0 ${NEWROOT}/var/log/audit
                ${NEWROOT}/usr/bin/setfacl -R -b ${NEWROOT}/var/log/
        else
                # chowner to secadm
                chown -R 600:600 ${securityfs_mnt}
                chown -R 600:600 ${NEWROOT}/etc/selinux
                chown -R 600:600 ${NEWROOT}/usr/share/selinux
                chown -R 600:600 ${NEWROOT}/var/lib/sepolgen
                chown -R 600:600 ${NEWROOT}/var/lib/selinux
                chown -R 700:700 ${NEWROOT}/etc/audi*
                chown -R 700:700 ${NEWROOT}/var/log/audit
                ${NEWROOT}/usr/bin/setfacl -R -m u:700:r-x ${NEWROOT}/var/log/
        fi
else
        chown -R 0:0 ${NEWROOT}/etc/selinux
        chown -R 0:0 ${NEWROOT}/usr/share/selinux
        chown -R 0:0 ${NEWROOT}/var/lib/sepolgen
        chown -R 0:0 ${NEWROOT}/var/lib/selinux
        chown -R 0:0 ${NEWROOT}/etc/audi*
        chown -R 0:0 ${NEWROOT}/var/log/audit
        ${NEWROOT}/usr/bin/setfacl -R -b ${NEWROOT}/var/log/
fi

if [ -f "$sysfs_entry" ] && [ -f "/.3adm" ]; then
	# enable 3adm
	cat /.3adm > "$sysfs_entry"
	rm -rf /.3adm
	info "kysec 3adm enabled"
fi

unset root_device
